//Do not edit! This file was generated by Unity-ROS MessageGeneration.
using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Unity.Robotics.ROSTCPConnector.MessageGeneration;

namespace RosMessageTypes.NiryoMoveit
{
    [Serializable]
    public class NiryoMoveitJointsMsg : Message
    {
        public const string k_RosMessageName = "niryo_moveit/NiryoMoveitJoints";
        public override string RosMessageName => k_RosMessageName;

        public double[] joints;
        public Geometry.PoseMsg pick_pose;
        public Geometry.PoseMsg grasp_pose;
        public Geometry.PoseMsg approach_pose;
        public Geometry.PoseMsg place_pose;

        public NiryoMoveitJointsMsg()
        {
            this.joints = new double[6];
            this.pick_pose = new Geometry.PoseMsg();
            this.grasp_pose = new Geometry.PoseMsg();
            this.approach_pose = new Geometry.PoseMsg();
            this.place_pose = new Geometry.PoseMsg();
        }

        public NiryoMoveitJointsMsg(double[] joints, Geometry.PoseMsg pick_pose, Geometry.PoseMsg grasp_pose, Geometry.PoseMsg approach_pose, Geometry.PoseMsg place_pose)
        {
            this.joints = joints;
            this.pick_pose = pick_pose;
            this.grasp_pose = grasp_pose;
            this.approach_pose = approach_pose;
            this.place_pose = place_pose;
        }

        public static NiryoMoveitJointsMsg Deserialize(MessageDeserializer deserializer) => new NiryoMoveitJointsMsg(deserializer);

        private NiryoMoveitJointsMsg(MessageDeserializer deserializer)
        {
            deserializer.Read(out this.joints, sizeof(double), 6);
            this.pick_pose = Geometry.PoseMsg.Deserialize(deserializer);
            this.grasp_pose = Geometry.PoseMsg.Deserialize(deserializer);
            this.approach_pose = Geometry.PoseMsg.Deserialize(deserializer);
            this.place_pose = Geometry.PoseMsg.Deserialize(deserializer);
        }

        public override void SerializeTo(MessageSerializer serializer)
        {
            serializer.Write(this.joints);
            serializer.Write(this.pick_pose);
            serializer.Write(this.grasp_pose);
            serializer.Write(this.approach_pose);
            serializer.Write(this.place_pose);
        }

        public override string ToString()
        {
            return "NiryoMoveitJointsMsg: " +
            "\njoints: " + System.String.Join(", ", joints.ToList()) +
            "\npick_pose: " + pick_pose.ToString() +
            "\ngrasp_pose: " + grasp_pose.ToString() +
            "\napproach_pose: " + approach_pose.ToString() +
            "\nplace_pose: " + place_pose.ToString();
        }

#if UNITY_EDITOR
        [UnityEditor.InitializeOnLoadMethod]
#else
        [UnityEngine.RuntimeInitializeOnLoadMethod]
#endif
        public static void Register()
        {
            MessageRegistry.Register(k_RosMessageName, Deserialize);
        }
    }
}
